------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2007-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
private with Ada.Finalization;
with Qt4.Points;
with Qt_Ada.Internals.Value_Class_Sizes;
with System;

package Qt4.Point_Fs is

   type Q_Point_F is tagged private;

   function Create
    (P : in Qt4.Points.Q_Point'Class)
       return Q_Point_F;

   function Create
    (Xpos : in Qt4.Q_Real;
     Ypos : in Qt4.Q_Real)
       return Q_Point_F;

   function Is_Null
    (Self : in Q_Point_F'Class)
       return Boolean;

   procedure Set_X
    (Self : in out Q_Point_F'Class;
     X : in Qt4.Q_Real);

   procedure Set_Y
    (Self : in out Q_Point_F'Class;
     Y : in Qt4.Q_Real);

   function To_Point
    (Self : in Q_Point_F'Class)
       return Qt4.Points.Q_Point;

   function X
    (Self : in Q_Point_F'Class)
       return Qt4.Q_Real;

   function Y
    (Self : in Q_Point_F'Class)
       return Qt4.Q_Real;

   function "="
    (P_1 : in Q_Point_F;
     P_2 : in Q_Point_F)
       return Boolean;

   function "+"
    (P_1 : in Q_Point_F;
     P_2 : in Q_Point_F)
       return Q_Point_F;

   function "-"
    (P_1 : in Q_Point_F;
     P_2 : in Q_Point_F)
       return Q_Point_F;

   function "*"
    (P : in Q_Point_F;
     S : in Qt4.Q_Real)
       return Q_Point_F;

   function "*"
    (S : in Qt4.Q_Real;
     P : in Q_Point_F)
       return Q_Point_F;

   function "-"
    (P : in Q_Point_F)
       return Q_Point_F;

   function "/"
    (P : in Q_Point_F;
     S : in Qt4.Q_Real)
       return Q_Point_F;

   package Internals is

      type QPointF is private;

      type QPointF_Access is access all QPointF;
      pragma Convention (C, QPointF_Access);

      function QPointF_View
       (Item : in Q_Point_F'Class)
          return QPointF_Access;
      pragma Inline (QPointF_View);

      function To_Pointer
       (Address : in System.Address)
          return QPointF_Access;
      pragma Inline (To_Pointer);

      function To_Address
       (Pointer : in QPointF_Access)
          return System.Address;
      pragma Inline (To_Address);

      function Create_Wrapper
       (Item : in Internals.QPointF_Access)
          return Q_Point_F;

   private

      type QPointF is record
         Placeholder : Interfaces.C.char_array (1 .. Qt_Ada.Internals.Value_Class_Sizes.QPointF_C_Size_Of);
      end record;
      pragma Convention (C, QPointF);

   end Internals;

private

   type Q_Point_F is new Ada.Finalization.Controlled with record
      Storage : aliased Internals.QPointF;
      Object  : Internals.QPointF_Access := null;
      Wrapper : Boolean := False;
   end record;

   overriding
   procedure Adjust (Self : in out Q_Point_F);

   overriding
   procedure Finalize (Self : in out Q_Point_F);

   overriding
   procedure Initialize (Self : in out Q_Point_F);

end Qt4.Point_Fs;
